#!/usr/bin/python3
import subprocess
import sys, os
import cgi
import cgitb, jinja2, urllib.request
import re
from pathlib import Path

cgitb.enable()
print("Content-Type: text/html\n\n")
HTML = '''<!DOCTYPE html>
<html><head>
<meta charset="UTF-8">
<title>Modern Menu</title>
<style>
  #menu {
    background-color: #bdf5fc;
    width: 200px; /* Adjust width as needed */
    padding: 20px;
    box-sizing: border-box;
  }

  #menu b {
    font-size: 24px; /* Larger font size for the menu title */
    color: #333; /* Darker color for better readability */
    margin-bottom: 20px; /* Space below the menu title */
    display: inline-block; /* To enable margin to work */
  }

  #menu a {
    display: block; /* Make each link take its own line */
    color: #007bff; /* A more vibrant link color */
    text-decoration: none; /* Remove underline */
    margin: 10px 0; /* Space between links */
    padding: 8px; /* Padding inside links for larger click area */
    border-radius: 5px; /* Rounded corners for links */
    transition: background-color 0.3s, color 0.3s; /* Smooth transition for hover effects */
  }

  #menu a:hover {
    background-color: #007bff; /* Background color on hover */
    color: #ffffff; /* Text color on hover */
  }

  /* Additional style to remove link spacing and align to the left */
  body {
    margin: 0;
    font-family: Arial, sans-serif; /* Modern font */
  }
</style>
<title></title>
</head>

<body>
  <div id="header" style="background-color:#00c062;text-align:center">
    <h1 style="margin-bottom:0;">Gruppe 7</h1>
  </div>

  <div id="menu" style="background-color:#bdf5fc; height:100%;float:left;padding: 10px;">
    <b>Menu</b><br>
    <a href="main.py">Main page</a><br>
    <br>
    <a href="cgiInput.py">Calculating GC Content</a><br>
    <br>
    <a href="GOR.py">Protein Secondary Structure Prediction</a><br>
    <br>
    <a href="cv.html">GOR validation report</a><br>
    <br>
    <a href="dna2protein.py">DNA2Protein</a><br>    
    <br>
    <a href="callAlignment.py">Alignment</a><br>
    <br>
    <a href="callValidation.py">Alignment Validation</a><br>
    <br>
    <a href="Correlations_Benchmarking_1.pdf">Alignment correlation and benchmarking</a><br>

  </div>
  <div id="introduction" style="background-color:#6affda; height:30%" <pre=""><br>
       Here you can run different GOR-prediction algorithms using a protein sequence or PDB ID('s).<br>      

  </div>
  <div id="input info" style="background-color:#fc9a00">
  <h3>Input and Output: </h3>
  <p> Input: a protein sequence in one letter code format or PDB ids separated by comma.<br>
  Output: SS predicted by a chosen GOR algorithm with statisctics and basic plots.<br>
  </p>  
  </div>
  
  {% if result == 1 %}
  
  <div id="content"> 
    <br><h3>Result:</h3><br>
    <br>
    <a href="detailed_statistics.txt" download>Statistics of the run</a><br>
    <br>
    <a href="summary.txt" download>Summary</a><br>  
    {% for id, link in links %}
    <br><a href="{{ link }}" target="_blank" download>{{ id }}</a><br>
    {% endfor %}
</div>


  {% else %}
    <h3>Please choose one form of input for each run: </h3>
    <script>
// Function to toggle visibility based on selectors
function toggleVisibility() {
    // Handle sequence/PDB ID toggle
    var selectionInputType = document.getElementById("inputType").value;
    document.getElementById("sequenceInput").style.display = selectionInputType == "sequence" ? "" : "none";
    document.getElementById("pdbidInput").style.display = selectionInputType == "pdbid" ? "" : "none";
    
    // Handle model/standard toggle
    var selectionInputType2 = document.getElementById("inputType2").value;
    document.getElementById("fileUploadBox").style.display = selectionInputType2 == "model" ? "" : "none";
}

// Set up event listeners on page load
document.addEventListener('DOMContentLoaded', function() {
    // Initial visibility setup
    toggleVisibility();
    
    // Setup change listeners
    document.getElementById("inputType").addEventListener("change", toggleVisibility);
    document.getElementById("inputType2").addEventListener("change", toggleVisibility);
});
</script>

<form action="GOR1-4.py" method="post" enctype="multipart/form-data" title="PDB ID and Protein Sequence">

    <select id="inputType">
        <option value="sequence" selected>Sequence</option>
        <option value="pdbid">PDB ID</option>
    </select><br><br>

    <div id="pdbidInput" style="display:none;">
        <label for="pdbid">PDB IDs, separated by comma:</label>
        <input type="text" name="pdbid" id="pdbid"><br><br>
    </div>

    <div id="sequenceInput">
        <label for="sequence">Protein Sequences in FASTA format:</label>
        <textarea name="sequence" id="sequence" rows="5"></textarea><br><br>
    </div>


    <select id="inputType2">
        <option value="model">Upload your own model</option>
        <option value="standard">Use our models</option>
    </select><br><br>

    <div id="fileUploadBox" style="display:none;">
        <input type="file" name="modelFile" id="modelFile">
    </div><br><br>

    <!-- Specify GOR Algorithm -->    <label for="method">Specify GOR Algorithm:</label>
    <select name="method" id="method">
        <option value="">Select a method...</option>
        <option value="GOR1">GOR1</option>
        <option value="GOR3">GOR3</option>
        <option value="GOR4">GOR4</option>
    </select><br><br>

<h5>Optional parameters:</h3>

<label for="k">k := window size for GOR prediction - our models require k=8:</label>
<input type="number" id="k" name="k"><div>Default=8</div><br><br>

<label for="sc">Smoothing constant used in GOR prediction (float):</label>
<input type="number" id="sc" name="sc" step="any"><br><br>


<label for="ppt">Type of post-processing to apply:</label>
<select id="ppt" name="ppt">
    <option value="">Select a post-processing method...</option>
    <option value="1">Strictly remove helices or strands >= l</option>
    <option value="2">Remove Smooth alternating patterns</option>
    <option value="3">Both</option>
</select><br><br>

<label for="l">l := maximum length of short structures to remove:</label>
<input type="number" id="l" name="l"><div>Recommended default: 2</div><br><br>
    

<input type="checkbox" id="probabilities" name="probabilities">
<label for="probabilities">Use probabilities instead of delta_I</label><br><br>

    <input type="submit" value="Submit">
</form>




{% endif %}

</body></html>'''





UPLOAD_DIR = 'uploads'
MODEL1 = 'model1_big.txt'
MODEL3 = 'model3_big.txt'
MODEL4 = 'model4_big.txt' 

form = cgi.FieldStorage()

# Getting form values
pdbids = form.getvalue('pdbid', '').strip()
sequence = form.getvalue('sequence', '').strip()
input_type = form.getvalue('inputType2', '')
selected_method = form.getvalue('method', '')
scaledValues = 'sv'
probabilities = 'p' if 'probabilities' in form else ''
k = form.getvalue('k', '8')
sc = form.getvalue('sc', '0.35')
sc = sc.replace(',', '.')
ppt = form.getvalue('ppt', '1')
l = form.getvalue('l', '2')


x = ''

def process_command(commands, output_path):
    """Run subprocess and handle file cleanup."""
    with open(output_path, 'w') as f:
        subprocess.run(commands, stdout=f, stderr=subprocess.PIPE)
    x1 = subprocess.run(['java', '-jar', 'validate1.jar', '-p', output_path, '-r', outFilePath1,
                    '-s', 'summary.txt', '-d', 'detailed_statistics.txt', '-f', 'txt'],
                   stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    
    #print(x1.stdout)
    #print(x1.stderr)
    #os.remove(output_path)

links = []
if selected_method:
    outFilePath1 = os.path.join(UPLOAD_DIR, "pred_seqs.txt")    
    if pdbids or sequence:
        # determine the correct model file based on the selection
        model_file = MODEL1 if selected_method == "GOR1" else MODEL3 if selected_method == "GOR3" else MODEL4
        if input_type == 'model' and 'modelFile' in form:
            #handling model file uploaded by the user
            premodel = form['modelFile']
            fileContent = premodel.file.read()
            model = os.path.join(UPLOAD_DIR, os.path.basename(premodel.filename))
            with open(model, "wb") as mFile:
                mFile.write(fileContent)
            model_file = model  # Use the uploaded model for prediction
        
        # Common command parts
        command = ['java', '-jar', 'predict.jar', '--model', model_file, '--format', 'txt', '--seq', outFilePath1]        
        if scaledValues:
            command.extend(['-sv'])
        if probabilities:
            command.extend(['-p'])
        if k:
            command.extend(['-k', k])
        if sc:            
            command.extend(['-sc', sc])
        if ppt:
            command.extend(['-ppt', ppt])
        if l:
            command.extend(['-l', l])
        if pdbids:
            pre_outname = "pdb_list.txt"
            outFilePath2 = os.path.join(UPLOAD_DIR, pre_outname)
            with open(outFilePath2, "w") as outFile:
                outFile.write(pdbids)
            subprocess.run(['python3', 'seclib_reader.py', '--pdb-id', outFilePath2, '--output', outFilePath1], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            process_command(command, 'uploads/pred_out.txt')

            public_html_path = os.getcwd()

            uploads_file_path = os.path.join(public_html_path, 'uploads', 'pred_out.txt')

            visual_folder_path = os.path.join(public_html_path, 'visual')

            # Modify the command to use the absolute path for the uploads file
            command = f'cat {uploads_file_path} | python3 visualPreds.py'

            # Run the command with the specified working directory
            subprocess.run(command, shell=True, cwd=visual_folder_path)
            pdbid_list = pdbids.split(',')
            links = [(id, f"visual/{id}visualisierungsseite.html") for id in pdbid_list]


        elif sequence:
            with open(outFilePath1, "w") as outFile:
                outFile.write(sequence)
            process_command(command, 'uploads/pred_out.txt')
        x = 1  
        
        # Cleanup
        if input_type == 'model' and 'modelFile' in form:
            os.remove(model)  # Clean up uploaded model file if any
    os.remove(outFilePath1)
    subprocess.run(["rm - rvf uploads/pred_out.txt uploads/pdb_list.txt"], shell=True)
    

headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:23.0) Gecko/20100101 Firefox/23.0'}
print(jinja2.Environment().from_string(HTML).render(result = x, links=links))
